## playmidi 2.3

=== Makefile ===
###########################################################################
# playmidi Makefile  last modification 2 January 1996
#
# by Nathan I Laredo, laredo@gnu.ai.mit.edu
#
# I don't wish to assert any rights (copyright) for this Makefile.
# This Makefile is specially designed for using "make install"
# thousands of times (for developing), and will only install updated
# files.  It does not write over exiting fm patch libs if you have them.
#
# 5/10/95 - Fixed a few bugs here and there. -- Alex
#
# 9/15/95 - Changed back to what I originally intended.
#
# 10/5/95 - Moved configurables to the start of Makefile, made variables
#           Added install for patch libraries
#
# 12/9/95 - Added stuff for xplaymidi, modified default paths for FSSTND
#           Any RedHat system should compile as is.
#
# 1/2/96  - Tried to document more completely, added some more objects
#           install.noX11, install.novga, install.Xonly, install.lame
#
# 1/5/96  - Added -DNARROWPROTO for xplaymidi
#
# 1/28/96 - Added options to make xview and xforms versions of xplaymidi
###########################################################################

# ncurses usually /usr/lib, -L/usr/local/lib doesn't hurt
# unless there's more than one ncurses floating around on your system
LIBNC	= -L/usr/local/lib -lncurses

######### NOTE:  X11R6 or newer REQUIRED
LIBX11	= -L/usr/X11R6/lib -lXaw -lXmu -lXt -lX11 -lXext -lSM -lICE
LIBVGA	= -L/usr/local/lib -lvgagl -lvga

# ncurses is usually in /usr/include/ncurses, but you may need
# to use /usr/local/include/ncurses depending on your setup.
INCNC	= -I/usr/include/ncurses

# just in case you keep your X includes in an odd location.
INCX11	= -I/usr/X11R6/include -DNARROWPROTO

# usually in /usr/include, but -I/usr/local/include doesn't hurt
# unless there's more than one svgalib floating around your system.
INCVGA	= -I/usr/local/include

# Directory where application defaults files are stored for X11 version
XAPPDEFAULTS = /usr/X11R6/lib/X11/app-defaults

INCLUDES= $(INCNC) $(INCX11) $(INCVGA)
INSTALLDIR = /usr/local/bin
INSTALL = install -s

# if you are using the GUS Ultra driver module, add -DULTRA_DRIVER
CFLAGS	= -Wall -pipe -fomit-frame-pointer -O2 -m486
LDFLAGS =

OBJECTS = playmidi.o readmidi.o playevents.o \
	  patchload.o emumidi.o io_ncurses.o

XOBJECTS= playmidi.o readmidi.o playevents.o \
	  patchload.o emumidi.o io_xaw.o

SOBJECTS= playmidi.o readmidi.o playevents.o \
	  patchload.o emumidi.o io_svgalib.o

all: playmidi splaymidi xplaymidi

config:
playmidi.h: playmidi.h-dist
	Configure

io_ncurses.o: io_ncurses.c
	$(CC) $(CFLAGS) $(INCNC) -c io_ncurses.c -o io_ncurses.o

io_xaw.o: io_xaw.c
	$(CC) $(CFLAGS) $(INCX11) -c io_xaw.c -o io_xaw.o

io_svgalib.o: io_svgalib.c
	$(CC) $(CFLAGS) $(INCVGA) -c io_svgalib.c -o io_svgalib.o

playmidi: .depend $(OBJECTS)
	$(CC) $(LDFLAGS) -o playmidi $(OBJECTS) $(LIBNC)

xplaymidi: .depend $(XOBJECTS)
	$(CC) $(LDFLAGS) -o xplaymidi $(XOBJECTS) $(LIBX11)

splaymidi: .depend $(SOBJECTS)
	$(CC) $(LDFLAGS) -o splaymidi $(SOBJECTS) $(LIBVGA)

$(INSTALLDIR)/playmidi: playmidi
	$(INSTALL) playmidi $(INSTALLDIR)

$(INSTALLDIR)/xplaymidi: xplaymidi
	$(INSTALL) xplaymidi $(INSTALLDIR)

$(INSTALLDIR)/splaymidi: splaymidi
	$(INSTALL) splaymidi $(INSTALLDIR)

/etc/std.o3:
	cp -i std.o3 /etc

/etc/drums.o3:
	cp -i drums.o3 /etc

/etc/std.sb:
	cp -i std.sb /etc

/etc/drums.sb:
	cp -i drums.sb /etc

$(XAPPDEFAULTS)/XPlaymidi:
	cp -i XPlaymidi.ad $(XAPPDEFAULTS)/XPlaymidi

install: $(INSTALLDIR)/playmidi $(INSTALLDIR)/splaymidi \
	 $(INSTALLDIR)/xplaymidi /etc/std.o3 /etc/drums.o3 \
	 /etc/std.sb /etc/drums.sb $(XAPPDEFAULTS)/XPlaymidi

install.novga: $(INSTALLDIR)/playmidi \
	 $(INSTALLDIR)/xplaymidi /etc/std.o3 /etc/drums.o3 \
	 /etc/std.sb /etc/drums.sb $(XAPPDEFAULTS)/XPlaymidi

install.noX11: $(INSTALLDIR)/playmidi $(INSTALLDIR)/splaymidi \
	 /etc/std.o3 /etc/drums.o3 /etc/std.sb /etc/drums.sb

install.Xonly: $(INSTALLDIR)/xplaymidi /etc/std.o3 /etc/drums.o3 \
	 /etc/std.sb /etc/drums.sb $(XAPPDEFAULTS)/XPlaymidi

install.lame: $(INSTALLDIR)/playmidi \
	 /etc/std.o3 /etc/drums.o3 /etc/std.sb /etc/drums.sb

install.man:
	 cp playmidi.1 /usr/man/man1/

clean:
	rm -f *.o playmidi splaymidi xplaymidi a.out

distclean: clean
	rm -f .depend  *~ *.bak playmidi.h config.sed


ifeq (.depend, $(wildcard .depend))
.depend depend dep: playmidi.h
	for i in *.c; do $(CPP) -M $(CFLAGS) $(INCLUDES) $$i; done >.depend

include .depend
else
depend dep:
	for i in *.c; do $(CPP) -M $(CFLAGS) $(INCLUDES) $$i; done >.depend

.depend: playmidi.h
	@echo
	@echo "Bad or missing .depend running 'make depend clean'"
	@echo
	$(MAKE) depend clean
	@echo
	@echo "Successful.  Trying to make again"
	@exit 0
endif

## playmidi 2.4debian

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 ###########################################################################
-# playmidi Makefile  last modification 2 January 1996
+# playmidi Makefile  12 September 1996
 #
 # by Nathan I Laredo, laredo@gnu.ai.mit.edu
 #
@@ -8,22 +8,6 @@
 # thousands of times (for developing), and will only install updated
 # files.  It does not write over exiting fm patch libs if you have them.
 #
-# 5/10/95 - Fixed a few bugs here and there. -- Alex
-#
-# 9/15/95 - Changed back to what I originally intended.
-#
-# 10/5/95 - Moved configurables to the start of Makefile, made variables
-#           Added install for patch libraries
-#
-# 12/9/95 - Added stuff for xplaymidi, modified default paths for FSSTND
-#           Any RedHat system should compile as is.
-#
-# 1/2/96  - Tried to document more completely, added some more objects
-#           install.noX11, install.novga, install.Xonly, install.lame
-#
-# 1/5/96  - Added -DNARROWPROTO for xplaymidi
-#
-# 1/28/96 - Added options to make xview and xforms versions of xplaymidi
 ###########################################################################
 
 # ncurses usually /usr/lib, -L/usr/local/lib doesn't hurt
@@ -32,6 +16,7 @@
 
 ######### NOTE:  X11R6 or newer REQUIRED
 LIBX11	= -L/usr/X11R6/lib -lXaw -lXmu -lXt -lX11 -lXext -lSM -lICE
+LIBGTK	= -L/usr/X11R6/lib -lgtk-1.1 -lgdk-1.1 -lglib-1.1 -lX11 -lXext -lm
 LIBVGA	= -L/usr/local/lib -lvgagl -lvga
 
 # ncurses is usually in /usr/include/ncurses, but you may need
@@ -41,6 +26,11 @@
 # just in case you keep your X includes in an odd location.
 INCX11	= -I/usr/X11R6/include -DNARROWPROTO
 
+# stuff for sound blaster awe32
+INCAWE  = -DVOXWARE_CONTROLLER_7_WORKING
+# awe_voice.h path
+INCAWE  += -I/usr/lib/oss/include/sys
+
 # usually in /usr/include, but -I/usr/local/include doesn't hurt
 # unless there's more than one svgalib floating around your system.
 INCVGA	= -I/usr/local/include
@@ -48,12 +38,12 @@
 # Directory where application defaults files are stored for X11 version
 XAPPDEFAULTS = /usr/X11R6/lib/X11/app-defaults
 
-INCLUDES= $(INCNC) $(INCX11) $(INCVGA)
-INSTALLDIR = /usr/local/bin
+INCLUDES= $(INCNC) $(INCX11) $(INCVGA) $(INCAWE)
+INSTALLDIR = /usr/bin
 INSTALL = install -s
 
 # if you are using the GUS Ultra driver module, add -DULTRA_DRIVER
-CFLAGS	= -Wall -pipe -fomit-frame-pointer -O2 -m486
+CFLAGS	= -Wall -pipe -fomit-frame-pointer -O2 -m486 $(INCAWE)
 LDFLAGS =
 
 OBJECTS = playmidi.o readmidi.o playevents.o \
@@ -65,11 +55,14 @@
 SOBJECTS= playmidi.o readmidi.o playevents.o \
 	  patchload.o emumidi.o io_svgalib.o
 
-all: playmidi splaymidi xplaymidi
+GOBJECTS= playmidi.o readmidi.o playevents.o \
+	  patchload.o emumidi.o io_gtk.o
+
+all: playmidi xplaymidi 
 
 config:
 playmidi.h: playmidi.h-dist
-	Configure
+	./Configure
 
 io_ncurses.o: io_ncurses.c
 	$(CC) $(CFLAGS) $(INCNC) -c io_ncurses.c -o io_ncurses.o
@@ -86,6 +79,9 @@
 xplaymidi: .depend $(XOBJECTS)
 	$(CC) $(LDFLAGS) -o xplaymidi $(XOBJECTS) $(LIBX11)
 
+gtkplaymidi: .depend $(GOBJECTS)
+	$(CC) $(LDFLAGS) -o gtkplaymidi $(GOBJECTS) $(LIBGTK)
+
 splaymidi: .depend $(SOBJECTS)
 	$(CC) $(LDFLAGS) -o splaymidi $(SOBJECTS) $(LIBVGA)
 
@@ -94,6 +90,9 @@
 
 $(INSTALLDIR)/xplaymidi: xplaymidi
 	$(INSTALL) xplaymidi $(INSTALLDIR)
+
+$(INSTALLDIR)/gtkplaymidi: gtkplaymidi
+	$(INSTALL) gtkplaymidi $(INSTALLDIR)
 
 $(INSTALLDIR)/splaymidi: splaymidi
 	$(INSTALL) splaymidi $(INSTALLDIR)
@@ -134,7 +133,7 @@
 	 cp playmidi.1 /usr/man/man1/
 
 clean:
-	rm -f *.o playmidi splaymidi xplaymidi a.out
+	rm -f *.o playmidi splaymidi xplaymidi a.out toy seq2mid beat
 
 distclean: clean
 	rm -f .depend  *~ *.bak playmidi.h config.sed

=== debian/changelog ===
playmidi (2.4debian-17) unstable; urgency=medium

  * QA upload.
  * Disable parallel build for now. Closes: #1076021.

 -- Santiago Vila <sanvila@debian.org>  Tue, 09 Jul 2024 19:25:00 +0200

playmidi (2.4debian-16) unstable; urgency=medium

  * QA upload.
  * Generate playmidi.h first, then build the program.
    This is a workaround for a Makefile bug.
  * Convert package to simplified dh syntax.
  * Apply changes from Helmut Grohne for cross-build. Closes: #914626.

 -- Santiago Vila <sanvila@debian.org>  Tue, 09 Jul 2024 18:10:00 +0200

playmidi (2.4debian-15) unstable; urgency=medium

  * QA upload.

  * Added d/gbp.conf to describe branch layout.
  * Updated vcs in d/control to Salsa.
  * Updated d/gbp.conf to enforce the use of pristine-tar.
  * Updated Standards-Version from 3.9.3 to 4.7.0.
  * Use wrap-and-sort -at for debian control files
  * Trim trailing whitespace.
  * debian/copyright: use spaces rather than tabs to start
    continuation lines.
  * debian/rules: Use dh_prep rather than "dh_clean -k".
  * Use set -e rather than passing -e on the shebang-line.
  * Bump debhelper from deprecated 7 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Corrected formatting and content of d/copyright.
  * Updated d/control, d/copyright with new home page location
    and added d/watch.
  * Moved some d/rules setup to individual files.
  * Flagged in d/control that no root build is needed.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 14 May 2024 08:34:40 +0200

playmidi (2.4debian-14) unstable; urgency=medium

  * QA upload.
  * Add missing include. (Closes: #1066401)

 -- Bastian Germann <bage@debian.org>  Thu, 14 Mar 2024 19:20:42 +0000

playmidi (2.4debian-13) unstable; urgency=medium

  * QA upload.
  * Convert to 3.0 source format. (Closes: #1007442)
  * d/copyright: Convert to machine-readable format.

 -- Bastian Germann <bage@debian.org>  Sat, 03 Dec 2022 10:11:08 +0100

playmidi (2.4debian-12) unstable; urgency=low

  * QA upload.
  * debian/compat: 5 -> 7. (Closes: #965784)
  * debian/rules: Add build-{arch,indep}. (Closes: #999014)

 -- Adrian Bunk <bunk@debian.org>  Tue, 28 Dec 2021 02:35:54 +0200

playmidi (2.4debian-11) unstable; urgency=medium

  * QA upload.
  * Set maintainer to Debian QA Group. (see #881511)
  * Add Brazilian Portuguese debconf templates translation
    from Adriano Rafael Gomes. (Closes: #719934)

 -- Adrian Bunk <bunk@debian.org>  Sun, 19 Nov 2017 20:32:52 +0200

playmidi (2.4debian-10) unstable; urgency=low

  * Change of maintainer address.
  * Bump standards version to 3.9.3; bump debhelper compat to 5 (minimal).
  * Copyright file fixups (lintian warning).
  * Use dpkg-buildflags for hardening.
  * Add a versioned build-dep on dpkg-dev.
  * Ack NMUs. (Closes: #463252, #488708, #489161, #654813, #665305)

 -- Darren Salt <devspam@moreofthesa.me.uk>  Tue, 20 Nov 2012 18:05:29 +0000

playmidi (2.4debian-9.2) unstable; urgency=low

  * Non-maintainer upload.
  * Fix pending l10n issues. Debconf translations:
    - Danish (Joe Hansen).  Closes: #654813
    - Polish (Michał Kułach).  Closes: #665305

 -- Christian Perrier <bubulle@debian.org>  Fri, 30 Mar 2012 06:52:44 +0200

playmidi (2.4debian-9.1) unstable; urgency=low

  * Non-maintainer upload to fix pending l10n issues.
  * Debconf translations
    - Japanese. Closes: #463252
    - Swedish. Closes: #488708
    - Norwegian Bokmål. Closes: #463252
    - Turkish. Closes: #489161

 -- Christian Perrier <bubulle@debian.org>  Thu, 19 Jun 2008 20:10:55 +0200

playmidi (2.4debian-9) unstable; urgency=low

  [ Darren Salt ]
  * Updated debconf templates & debian/control.		(Closes: #452496)
    Reviewed by the debian-l10n-english team as part of the Smith review
    project (except that I've lightly tweaked the last sentence of the
    package description).
  * Various new & updated debconf translations:
    - Basque						(Closes: #453297)
    - Galician						(Closes: #453330)
    - Vietnamese					(Closes: #453377)
    - German						(Closes: #453488)
    - Finnish						(Closes: #453655)
    - Portuguese					(Closes: #453914)
    - Spanish, Castilian				(Closes: #454357)
    - Italian						(Closes: #454645)
    - French						(Closes: #454648)
    - Czech						(Closes: #455239)
    - Dutch, Flemish					(Closes: #455869)
    - Russian						(Closes: #455965)
  * Demote the X dependencies to Recommends.		(Closes: #28471)
    Use a wrapper for xplaymidi to avoid run-time linkage errors.
    (Doable since recommended packages are installed by default.)
  * Bumped standards version to 3.7.3; no changes needed.

 -- Darren Salt <linux@youmustbejoking.demon.co.uk>  Fri, 18 Jan 2008 22:18:33 +0000

playmidi (2.4debian-8) unstable; urgency=low

  * Use debian/compat instead of DH_COMPAT, but stick with level 4 for now.
  * Updated standards version to 3.7.2.
  * Templates converted to UTF-8.
  * Fixed problems with terminal resize (ncurses interface) - now no longer
    terminates.
  * Use intptr_t for pointer casting.
  * Switched to using the included awe_voice.h regardless of target.
    It was removed from Linux between 2.6.21 & 2.6.22.	(Closes: #436329)
  * Added Dutch debconf translation.			(Closes: #414771)
  * Added Portuguese debconf translation.		(Closes: #434062)
  * Fixed the --help option.				(Closes: #418819)
  * Removed a question mark from the debconf template. Translations need to
    be updated to remove the malformed-prompt-in-templates warning.

 -- Darren Salt <linux@youmustbejoking.demon.co.uk>  Sun, 28 Oct 2007 01:58:59 +0100

playmidi (2.4debian-7) unstable; urgency=low

  * Added Spanish templates translation.		(Closes: #404789)

 -- Darren Salt <linux@youmustbejoking.demon.co.uk>  Thu, 28 Dec 2006 18:43:33 +0000

playmidi (2.4debian-6) unstable; urgency=low

  * Fixed up various compiler warnings (mostly signedness differences which,
    in this case, was all noise).
  * Should be libxaw?-dev in previous changelog entries.


=== debian/control ===
Source: playmidi
Section: sound
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Standards-Version: 4.7.0
Build-Depends: debhelper-compat (= 13),
               libncurses-dev,
               libxaw7-dev,
               libxt-dev,
Homepage: https://nlaredo.github.io/playmidi.html
Vcs-Browser: https://salsa.debian.org/debian/playmidi
Vcs-Git: https://salsa.debian.org/debian/playmidi.git
Rules-Requires-Root: no

Package: playmidi
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Recommends: ${shlibs:Recommends},
Conflicts: suidmanager (<< 0.50),
Suggests: awesfx,
Description: MIDI player
 Playmidi is a MIDI file player that will play back using FM, GUS,
 SoundBlaster or external MIDI. It also supports Creative Music Files
 (CMF), Microsoft RIFF (RMI) files and large MIDI archives from games
 such as Ultima 7.
 .
 The player may be used with a text interface or a graphical interface.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --no-parallel

override_dh_auto_configure:
	echo 2 | $(MAKE) INCNC= INCAWE= playmidi.h

override_dh_auto_build: debian/po/templates.pot
	dh_auto_build -- INCNC= INCAWE= playmidi xplaymidi
	# compile xplaymidi wrapper
	sh debian/xplaymidi.sh

debian/po/templates.pot: debian/templates
	debconf-updatepo

override_dh_auto_clean:
	rm -f debian/xplaymidi.c debian/xplaymidi
	echo 2 | $(MAKE) distclean
	dh_clean

override_dh_auto_install:
	install -m644 XPlaymidi.ad debian/playmidi/etc/X11/app-defaults/XPlaymidi

execute_after_dh_installexamples:
	set -e && cd debian/midi && find -type f | sed -e 's/\.uue$$//' | \
	  while read i; do \
	    perl -e 'undef $$/; $$file = <> or die; print unpack ("u", $$file) or die' \
		<$$i.uue >../../debian/playmidi/usr/share/doc/playmidi/examples/$$i; \
	  done

override_dh_shlibdeps:
	dh_shlibdeps -ldebian/playmidi -- -dDepends debian/playmidi/usr/bin/playmidi -dRecommends debian/playmidi/usr/bin/xplaymidi

=== debian/watch ===
version=4
opts=repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/xball-\$1\.tar\.gz/,\
uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/ \
  https://github.com/nlaredo/playmidi/tags .*/v?(\d\S*)\.tar\.gz
